# 公開研究ソースを読む

正規URL： https://sosoapi.ai/ja/docs/api/research-api-evidence-retrieve

契約: sha256:ab393e91e9b7f18a

限定的な公開 HTTPS テキストまたは公開済み字幕を取得します。mutation_id を再利用し、対応範囲と信頼できないテキストを確認します。agent:research が必要です。

POST /research-api/evidence/retrieve

## 認証と権限

- **受け付ける認証情報の種類:** user_session, delegated_oauth, personal_access_token

- **委任された機能権限:** agent:research

- **ワークスペースの最低ロール:** editor

- **アクセス範囲:** このユーザーがアクセスを許可されたリソース

- **すべてのワークスペースへの同意が必要:** いいえ

- **状態を変更:** はい

- **操作完了時:** 永続的な限定読み取り受領記録と現在の証拠。非対応や未確認は成功ではありません

トークンは所有者の権利内でのみ使えます。各要求で所属、リソース所有権、選択ワークスペース、付与機能を確認します。coreとfullは表示だけを変え、アクセスは付与しません。

## リクエストのフィールド

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "url": {
      "type": "string",
      "maxLength": 2048,
      "format": "uri"
    },
    "kind": {
      "type": "string",
      "enum": [
        "url_text",
        "published_captions"
      ]
    },
    "language": {
      "type": "string",
      "minLength": 1,
      "maxLength": 35,
      "pattern": "^[a-zA-Z]{2,8}(?:-[a-zA-Z0-9]{1,8})*$"
    },
    "workspace_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    },
    "mutation_id": {
      "type": "string",
      "format": "uuid",
      "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
    }
  },
  "required": [
    "url",
    "kind",
    "workspace_id",
    "mutation_id"
  ],
  "additionalProperties": false
}
```

## レスポンスと完了条件

成功時のHTTPステータス： 200

HTTP成功は完了ではなく受理の場合があります。バックグラウンド処理はIDを保存し、同じ処理を完了まで確認します。予約・受理された投稿はプラットフォーム確認後のみ公開済みです。タイムアウトだけでは結果を判断できません。

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "retrieval": {
      "type": "object",
      "properties": {
        "id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "workspace_id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "mutation_id": {
          "type": "string",
          "format": "uuid",
          "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
        },
        "state": {
          "type": "string",
          "enum": [
            "pending",
            "running",
            "completed",
            "cancelled",
            "unconfirmed",
            "expired"
          ]
        },
        "kind": {
          "anyOf": [
            {
              "type": "string",
              "enum": [
                "url_text",
                "published_captions"
              ]
            },
            {
              "type": "null"
            }
          ]
        },
        "created_at": {
          "type": "string",
          "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
          "format": "date-time"
        },
        "settled_at": {
          "anyOf": [
            {
              "type": "string",
              "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
              "format": "date-time"
            },
            {
              "type": "null"
            }
          ]
        },
        "valid_until": {
          "type": "string",
          "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
          "format": "date-time"
        },
        "result": {
          "anyOf": [
            {
              "type": "object",
              "properties": {
                "kind": {
                  "type": "string",
                  "enum": [
                    "url_text",
                    "published_captions"
                  ]
                },
                "status": {
                  "type": "string",
                  "enum": [
                    "ready",
                    "partial",
                    "blocked",
                    "unsupported",
                    "empty",
                    "rate_limited",
                    "unavailable",
                    "cancelled"
                  ]
                },
                "text": {
                  "type": "string",
                  "maxLength": 20000
                },
                "title": {
                  "anyOf": [
                    {
                      "type": "string",
                      "minLength": 1,
                      "maxLength": 200
                    },
                    {
                      "type": "null"
                    }
                  ]
                },
                "description": {
                  "anyOf": [
                    {
                      "type": "string",
                      "minLength": 1,
                      "maxLength": 2000
                    },
                    {
                      "type": "null"
                    }
                  ]
                },
                "segments": {
                  "maxItems": 1000,
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "start_ms": {
                        "type": "integer",
                        "minimum": 0,
                        "maximum": 9007199254740991
                      },
                      "end_ms": {
                        "type": "integer",
                        "exclusiveMinimum": 0,
                        "maximum": 9007199254740991
                      },
                      "text": {
                        "type": "string",
                        "minLength": 1,
                        "maxLength": 20000
                      }
                    },
                    "required": [
                      "start_ms",
                      "end_ms",
                      "text"
                    ]
                  }
                },
                "provenance": {
                  "type": "object",
                  "properties": {
                    "source_url": {
                      "anyOf": [
                        {
                          "type": "string",
                          "maxLength": 2048,
                          "format": "uri"
                        },
                        {
                          "type": "null"
                        }
                      ]
                    },
                    "retrieved_at": {
                      "type": "string",
                      "pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
                      "format": "date-time"
                    },
                    "mime_type": {
                      "anyOf": [
                        {
                          "type": "string",
                          "enum": [
                            "text/html",
                            "application/xhtml+xml",
                            "text/plain",
                            "text/vtt",
                            "application/x-subrip",
                            "application/srt",
                            "text/srt"
                          ]
                        },
                        {
                          "type": "null"
                        }
                      ]
                    },
                    "parser_version": {
                      "type": "string",
                      "const": "research-public-retrieval/v1"
                    },
                    "content_kind": {
                      "type": "string",
                      "enum": [
                        "document_text",
                        "metadata_only",
                        "published_caption_file",
                        "none"
                      ]
                    },
                    "caption_format": {
                      "anyOf": [
                        {
                          "type": "string",
                          "enum": [
                            "webvtt",
                            "subrip"
                          ]
                        },
                        {
                          "type": "null"
                        }
                      ]
                    },
                    "language": {
                      "anyOf": [
                        {
                          "type": "string",
                          "minLength": 1,
                          "maxLength": 35,
                          "pattern": "^[a-zA-Z]{2,8}(?:-[a-zA-Z0-9]{1,8})*$"
                        },
                        {
                          "type": "null"
                        }
                      ]
                    },
                    "language_source": {
                      "type": "string",
                      "enum": [
                        "publisher_declared",
                        "unknown"
                      ]
                    },
                    "platform_native_verified": {
                      "type": "boolean",
                      "const": false
                    }
                  },
                  "required": [
                    "source_url",
                    "retrieved_at",
                    "mime_type",
                    "parser_version",
                    "content_kind",
                    "caption_format",
                    "language",
                    "language_source",
                    "platform_native_verified"
                  ]
                },
                "reason": {
                  "anyOf": [
                    {
                      "type": "string",
                      "enum": [
                        "unsafe_url",
                        "unsupported_source",
                        "unsupported_media",
                        "unsupported_content",
                        "access_denied",
                        "login_required",
                        "no_text",
                        "metadata_only",
                        "no_captions",
                        "invalid_captions",
                        "not_found",
                        "rate_limited",
                        "response_too_large",
                        "text_limited",
                        "nodes_limited",
                        "cues_limited",
                        "invalid_cues",
                        "language_mismatch",
                        "source_partial",
                        "timeout",
                        "cancelled",
                        "egress_unavailable",
                        "unavailable"
                      ]
                    },
                    {
                      "type": "null"
                    }
                  ]
                },
                "warnings": {
                  "maxItems": 10,
                  "type": "array",
                  "items": {
                    "type": "string",
                    "enum": [
                      "unsafe_url",
                      "unsupported_source",
                      "unsupported_media",
                      "unsupported_content",
                      "access_denied",
                      "login_required",
                      "no_text",
                      "metadata_only",
                      "no_captions",
                      "invalid_captions",
                      "not_found",
                      "rate_limited",
                      "response_too_large",
                      "text_limited",
                      "nodes_limited",
                      "cues_limited",
                      "invalid_cues",
                      "language_mismatch",
                      "source_partial",
                      "timeout",
                      "cancelled",
                      "egress_unavailable",
                      "unavailable"
                    ]
                  }
                },
                "retry_after_seconds": {
                  "anyOf": [
                    {
                      "type": "integer",
                      "minimum": 1,
                      "maximum": 86400
                    },
                    {
                      "type": "null"
                    }
                  ]
                }
              },
              "required": [
                "kind",
                "status",
                "text",
                "title",
                "description",
                "segments",
                "provenance",
                "reason",
                "warnings",
                "retry_after_seconds"
              ]
            },
            {
              "type": "null"
            }
          ]
        },
        "evidence": {
          "anyOf": [
            {
              "type": "object",
              "properties": {
                "evidence_id": {
                  "type": "string",
                  "format": "uuid",
                  "pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
                },
                "revision": {
                  "type": "integer",
                  "exclusiveMinimum": 0,
                  "maximum": 9007199254740991
                }
              },
              "required": [
                "evidence_id",
                "revision"
              ]
            },
            {
              "type": "null"
            }
          ]
        }
      },
      "required": [
        "id",
        "workspace_id",
        "mutation_id",
        "state",
        "kind",
        "created_at",
        "settled_at",
        "valid_until",
        "result",
        "evidence"
      ]
    }
  },
  "required": [
    "retrieval"
  ]
}
```

## エラーと安全な再試行

HTTPステータスとレスポンス本文を確認します。400の検証エラーにはZodErrorが含まれる場合があります。ハンドラーエラーはerror、message、codeを使用します。診断用にrequest_idまたはx-request-idを保持し、認証情報は含めないでください。401/403はアクセス問題を解消してから再試行し、429はRetry-Afterに従います。書き込み結果が不確か、または5xxの場合は、まず既存の結果を取得してください。冪等性キーは対応する操作でのみ再利用します。再試行の挙動は操作ごとに異なり、厳密に一回の配信は保証しません。

## 例

スキーマ確認済みの架空値の例です。認可されたID、準備済みメディア、確認済みの公開日時に置き換え、書き込み前に適格性を確認してください。このページはAPIを呼びません。

サーバーのSOSOAPI_ACCESS_TOKENに操作が受け付ける認証情報を設定し、ブラウザーコードに含めないでください。AIエージェントはsosoapi auth loginでブラウザーログインし、CLIに更新を任せます。

request.json

```json
{
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "40000000-0000-4000-8000-000000000001",
  "url": "https://example.com/research-notes",
  "kind": "url_text"
}
```

cURL

```bash
curl --request POST \
  "https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/evidence/retrieve" \
  -H "Authorization: Bearer $SOSOAPI_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  --data-binary @request.json
```

JavaScript

```js
// Server-side JavaScript. Do not print tokens or credential-bearing responses.
const token = process.env.SOSOAPI_ACCESS_TOKEN;
if (!token) throw new Error("Set an accepted credential for this operation");
const response = await fetch("https://gqeshlawtcexsapabaui.supabase.co/functions/v1/research-api/evidence/retrieve", {
  method: "POST",
  headers: { "Content-Type": "application/json", Authorization: "Bearer " + token },
  body: JSON.stringify({
  "workspace_id": "11111111-1111-4111-8111-111111111111",
  "mutation_id": "40000000-0000-4000-8000-000000000001",
  "url": "https://example.com/research-notes",
  "kind": "url_text"
})
});
const result = await response.json();
// Check response.ok, the operation-specific body and completion state before continuing.
```

CLI

```bash
npx sosoapi api post /research-api/evidence/retrieve < request.json
```

合成レスポンス例

```json
{
  "retrieval": {
    "id": "30000000-0000-4000-8000-000000000007",
    "workspace_id": "11111111-1111-4111-8111-111111111111",
    "mutation_id": "40000000-0000-4000-8000-000000000001",
    "state": "completed",
    "kind": "url_text",
    "created_at": "2099-01-15T09:00:00Z",
    "settled_at": "2099-01-15T09:00:01Z",
    "valid_until": "2099-01-16T09:00:00Z",
    "evidence": null,
    "result": {
      "kind": "url_text",
      "status": "unavailable",
      "text": "",
      "title": null,
      "description": null,
      "segments": [],
      "provenance": {
        "source_url": null,
        "retrieved_at": "2099-01-15T09:00:01Z",
        "mime_type": null,
        "parser_version": "research-public-retrieval/v1",
        "content_kind": "none",
        "caption_format": null,
        "language": null,
        "language_source": "unknown",
        "platform_native_verified": false
      },
      "reason": "unavailable",
      "warnings": [],
      "retry_after_seconds": null
    }
  }
}
```

## 関連ツールとガイド

MCP: sosoapi_research_evidence_retrieve

[APIリファレンス](https://sosoapi.ai/ja/docs/api)
